Index: uspace/app/tester/fault/fault2.c
===================================================================
--- uspace/app/tester/fault/fault2.c	(revision a634485c00ca23ba2df2fecef2d928929debee43)
+++ uspace/app/tester/fault/fault2.c	(revision a000878c0dee83a08f032207ffd800c201fca95b)
@@ -32,5 +32,5 @@
 typedef int __attribute__((may_alias)) aliasing_int;
 
-char *test_fault2(void)
+const char *test_fault2(void)
 {
 	volatile long long var;
Index: uspace/app/tester/fault/fault3.c
===================================================================
--- uspace/app/tester/fault/fault3.c	(revision a634485c00ca23ba2df2fecef2d928929debee43)
+++ uspace/app/tester/fault/fault3.c	(revision a000878c0dee83a08f032207ffd800c201fca95b)
@@ -30,5 +30,5 @@
 #include <stdlib.h>
 
-char *test_fault3(void)
+const char *test_fault3(void)
 {
 	abort();
Index: uspace/app/tester/ipc/connect.c
===================================================================
--- uspace/app/tester/ipc/connect.c	(revision a634485c00ca23ba2df2fecef2d928929debee43)
+++ uspace/app/tester/ipc/connect.c	(revision a000878c0dee83a08f032207ffd800c201fca95b)
@@ -39,5 +39,5 @@
 }
 
-char *test_connect(void)
+const char *test_connect(void)
 {
 	TPRINTF("Connecting to %u...", IPC_TEST_SERVICE);
Index: uspace/app/tester/ipc/ping_pong.c
===================================================================
--- uspace/app/tester/ipc/ping_pong.c	(revision a634485c00ca23ba2df2fecef2d928929debee43)
+++ uspace/app/tester/ipc/ping_pong.c	(revision a000878c0dee83a08f032207ffd800c201fca95b)
@@ -38,5 +38,5 @@
 #define COUNT_GRANULARITY  100
 
-char *test_ping_pong(void)
+const char *test_ping_pong(void)
 {
 	TPRINTF("Pinging ns server for %d seconds...", DURATION_SECS);
Index: uspace/app/tester/ipc/register.c
===================================================================
--- uspace/app/tester/ipc/register.c	(revision a634485c00ca23ba2df2fecef2d928929debee43)
+++ uspace/app/tester/ipc/register.c	(revision a000878c0dee83a08f032207ffd800c201fca95b)
@@ -74,5 +74,5 @@
 }
 
-char *test_register(void)
+const char *test_register(void)
 {
 	async_set_client_connection(client_connection);
Index: uspace/app/tester/loop/loop1.c
===================================================================
--- uspace/app/tester/loop/loop1.c	(revision a634485c00ca23ba2df2fecef2d928929debee43)
+++ uspace/app/tester/loop/loop1.c	(revision a000878c0dee83a08f032207ffd800c201fca95b)
@@ -31,5 +31,5 @@
 #include "../tester.h"
 
-char *test_loop1(void)
+const char *test_loop1(void)
 {
 	TPRINTF("Looping...");
Index: uspace/app/tester/mm/malloc1.c
===================================================================
--- uspace/app/tester/mm/malloc1.c	(revision a634485c00ca23ba2df2fecef2d928929debee43)
+++ uspace/app/tester/mm/malloc1.c	(revision a000878c0dee83a08f032207ffd800c201fca95b)
@@ -73,5 +73,5 @@
 
 typedef struct {
-	char *name;
+	const char *name;
 	sp_term_cond_s cond;
 	sp_action_prob_s prob;
@@ -90,5 +90,5 @@
 
 typedef struct {
-	char *name;
+	const char *name;
 	ph_alloc_size_s alloc;
 	subphase_s *subphases;
@@ -628,5 +628,5 @@
 }
 
-char *test_malloc1(void)
+const char *test_malloc1(void)
 {
 	init_mem();
Index: uspace/app/tester/print/print1.c
===================================================================
--- uspace/app/tester/print/print1.c	(revision a634485c00ca23ba2df2fecef2d928929debee43)
+++ uspace/app/tester/print/print1.c	(revision a000878c0dee83a08f032207ffd800c201fca95b)
@@ -31,5 +31,5 @@
 #include "../tester.h"
 
-char *test_print1(void)
+const char *test_print1(void)
 {
 	TPRINTF("Testing printf(\"%%*.*s\", 5, 3, \"text\"):\n");
Index: uspace/app/tester/print/print2.c
===================================================================
--- uspace/app/tester/print/print2.c	(revision a634485c00ca23ba2df2fecef2d928929debee43)
+++ uspace/app/tester/print/print2.c	(revision a000878c0dee83a08f032207ffd800c201fca95b)
@@ -31,5 +31,5 @@
 #include "../tester.h"
 
-char *test_print2(void)
+const char *test_print2(void)
 {
 	TPRINTF("Testing printf(\"%%c %%3.2c %%-3.2c %%2.3c %%-2.3c\", 'a', 'b', 'c', 'd', 'e'):\n");
Index: uspace/app/tester/print/print3.c
===================================================================
--- uspace/app/tester/print/print3.c	(revision a634485c00ca23ba2df2fecef2d928929debee43)
+++ uspace/app/tester/print/print3.c	(revision a000878c0dee83a08f032207ffd800c201fca95b)
@@ -34,5 +34,5 @@
 #define BUFFER_SIZE  32
 
-char *test_print3(void)
+const char *test_print3(void)
 {
 	char buffer[BUFFER_SIZE];
Index: uspace/app/tester/print/print4.c
===================================================================
--- uspace/app/tester/print/print4.c	(revision a634485c00ca23ba2df2fecef2d928929debee43)
+++ uspace/app/tester/print/print4.c	(revision a000878c0dee83a08f032207ffd800c201fca95b)
@@ -31,5 +31,5 @@
 #include "../tester.h"
 
-char *test_print4(void)
+const char *test_print4(void)
 {
 	TPRINTF("ASCII printable characters (32 - 127) using printf(\"%%c\") and printf(\"%%lc\"):\n");
Index: uspace/app/tester/stdio/stdio1.c
===================================================================
--- uspace/app/tester/stdio/stdio1.c	(revision a634485c00ca23ba2df2fecef2d928929debee43)
+++ uspace/app/tester/stdio/stdio1.c	(revision a000878c0dee83a08f032207ffd800c201fca95b)
@@ -36,8 +36,8 @@
 static char buf[BUF_SIZE + 1];
 
-char *test_stdio1(void)
+const char *test_stdio1(void)
 {
 	FILE *file;
-	char *file_name = "/readme";
+	const char *file_name = "/readme";
 	
 	TPRINTF("Open file \"%s\"...", file_name);
Index: uspace/app/tester/stdio/stdio2.c
===================================================================
--- uspace/app/tester/stdio/stdio2.c	(revision a634485c00ca23ba2df2fecef2d928929debee43)
+++ uspace/app/tester/stdio/stdio2.c	(revision a000878c0dee83a08f032207ffd800c201fca95b)
@@ -32,8 +32,8 @@
 #include "../tester.h"
 
-char *test_stdio2(void)
+const char *test_stdio2(void)
 {
 	FILE *file;
-	char *file_name = "/test";
+	const char *file_name = "/test";
 	
 	TPRINTF("Open file \"%s\" for writing...", file_name);
Index: uspace/app/tester/tester.c
===================================================================
--- uspace/app/tester/tester.c	(revision a634485c00ca23ba2df2fecef2d928929debee43)
+++ uspace/app/tester/tester.c	(revision a000878c0dee83a08f032207ffd800c201fca95b)
@@ -69,5 +69,5 @@
 {
 	/* Execute the test */
-	char *ret = test->entry();
+	const char *ret = test->entry();
 	
 	if (ret == NULL) {
Index: uspace/app/tester/tester.h
===================================================================
--- uspace/app/tester/tester.h	(revision a634485c00ca23ba2df2fecef2d928929debee43)
+++ uspace/app/tester/tester.h	(revision a000878c0dee83a08f032207ffd800c201fca95b)
@@ -54,30 +54,30 @@
 	}
 
-typedef char *(*test_entry_t)(void);
+typedef const char *(*test_entry_t)(void);
 
 typedef struct {
-	char *name;
-	char *desc;
+	const char *name;
+	const char *desc;
 	test_entry_t entry;
 	bool safe;
 } test_t;
 
-extern char *test_thread1(void);
-extern char *test_print1(void);
-extern char *test_print2(void);
-extern char *test_print3(void);
-extern char *test_print4(void);
-extern char *test_console1(void);
-extern char *test_stdio1(void);
-extern char *test_stdio2(void);
-extern char *test_fault1(void);
-extern char *test_fault2(void);
-extern char *test_fault3(void);
-extern char *test_vfs1(void);
-extern char *test_ping_pong(void);
-extern char *test_register(void);
-extern char *test_connect(void);
-extern char *test_loop1(void);
-extern char *test_malloc1(void);
+extern const char *test_thread1(void);
+extern const char *test_print1(void);
+extern const char *test_print2(void);
+extern const char *test_print3(void);
+extern const char *test_print4(void);
+extern const char *test_console1(void);
+extern const char *test_stdio1(void);
+extern const char *test_stdio2(void);
+extern const char *test_fault1(void);
+extern const char *test_fault2(void);
+extern const char *test_fault3(void);
+extern const char *test_vfs1(void);
+extern const char *test_ping_pong(void);
+extern const char *test_register(void);
+extern const char *test_connect(void);
+extern const char *test_loop1(void);
+extern const char *test_malloc1(void);
 
 extern test_t tests[];
Index: uspace/app/tester/thread/thread1.c
===================================================================
--- uspace/app/tester/thread/thread1.c	(revision a634485c00ca23ba2df2fecef2d928929debee43)
+++ uspace/app/tester/thread/thread1.c	(revision a000878c0dee83a08f032207ffd800c201fca95b)
@@ -50,5 +50,5 @@
 }
 
-char *test_thread1(void)
+const char *test_thread1(void)
 {
 	unsigned int i;
Index: uspace/app/tester/vfs/vfs1.c
===================================================================
--- uspace/app/tester/vfs/vfs1.c	(revision a634485c00ca23ba2df2fecef2d928929debee43)
+++ uspace/app/tester/vfs/vfs1.c	(revision a000878c0dee83a08f032207ffd800c201fca95b)
@@ -54,5 +54,5 @@
 static char text[] = "Lorem ipsum dolor sit amet, consectetur adipisicing elit";
 
-static char *read_root(void)
+static const char *read_root(void)
 {
 	TPRINTF("Opening the root directory...");
@@ -73,5 +73,5 @@
 }
 
-char *test_vfs1(void)
+const char *test_vfs1(void)
 {
 	if (mkdir(MOUNT_POINT, 0) != 0)
@@ -121,5 +121,5 @@
 	close(fd0);
 	
-	char *rv = read_root();
+	const char *rv = read_root();
 	if (rv != NULL)
 		return rv;
Index: uspace/app/tetris/screen.c
===================================================================
--- uspace/app/tetris/screen.c	(revision a634485c00ca23ba2df2fecef2d928929debee43)
+++ uspace/app/tetris/screen.c	(revision a000878c0dee83a08f032207ffd800c201fca95b)
@@ -72,5 +72,5 @@
  * simply literal strings);
  */
-static inline void putstr(char *s)
+static inline void putstr(const char *s)
 {
 	while (*s)
@@ -181,5 +181,5 @@
 }
 
-void stop(char *why)
+void stop(const char *why)
 {
 	if (isset)
Index: uspace/app/tetris/tetris.h
===================================================================
--- uspace/app/tetris/tetris.h	(revision a634485c00ca23ba2df2fecef2d928929debee43)
+++ uspace/app/tetris/tetris.h	(revision a000878c0dee83a08f032207ffd800c201fca95b)
@@ -186,5 +186,5 @@
 extern int fits_in(const struct shape *, int);
 extern void place(const struct shape *, int, int);
-extern void stop(char *);
+extern void stop(const char *);
 
 /** @}
Index: uspace/app/trace/errors.h
===================================================================
--- uspace/app/trace/errors.h	(revision a634485c00ca23ba2df2fecef2d928929debee43)
+++ uspace/app/trace/errors.h	(revision a000878c0dee83a08f032207ffd800c201fca95b)
@@ -37,6 +37,6 @@
 
 typedef struct {
-	char *name;	/**< Error value name (Exx) */
-	char *desc;	/**< Error description */
+	const char *name;  /**< Error value name (Exx) */
+	const char *desc;  /**< Error description */
 } err_desc_t;
 
Index: uspace/app/trace/ipc_desc.h
===================================================================
--- uspace/app/trace/ipc_desc.h	(revision a634485c00ca23ba2df2fecef2d928929debee43)
+++ uspace/app/trace/ipc_desc.h	(revision a000878c0dee83a08f032207ffd800c201fca95b)
@@ -38,5 +38,5 @@
 typedef struct {
 	int number;
-	char *name;
+	const char *name;
 } ipc_m_desc_t;
 
Index: uspace/app/trace/proto.c
===================================================================
--- uspace/app/trace/proto.c	(revision a634485c00ca23ba2df2fecef2d928929debee43)
+++ uspace/app/trace/proto.c	(revision a000878c0dee83a08f032207ffd800c201fca95b)
@@ -157,5 +157,5 @@
 }
 
-static void proto_struct_init(proto_t *proto, char *name)
+static void proto_struct_init(proto_t *proto, const char *name)
 {
 	proto->name = name;
@@ -164,5 +164,5 @@
 }
 
-proto_t *proto_new(char *name)
+proto_t *proto_new(const char *name)
 {
 	proto_t *p;
@@ -206,10 +206,10 @@
 }
 
-static void oper_struct_init(oper_t *oper, char *name)
+static void oper_struct_init(oper_t *oper, const char *name)
 {
 	oper->name = name;
 }
 
-oper_t *oper_new(char *name, int argc, val_type_t *arg_types,
+oper_t *oper_new(const char *name, int argc, val_type_t *arg_types,
     val_type_t rv_type, int respc, val_type_t *resp_types)
 {
Index: uspace/app/trace/proto.h
===================================================================
--- uspace/app/trace/proto.h	(revision a634485c00ca23ba2df2fecef2d928929debee43)
+++ uspace/app/trace/proto.h	(revision a000878c0dee83a08f032207ffd800c201fca95b)
@@ -43,5 +43,5 @@
 
 typedef struct {
-	char *name;
+	const char *name;
 
 	int argc;
@@ -56,5 +56,5 @@
 typedef struct {
 	/** Protocol name */
-	char *name;
+	const char *name;
 
 	/** Maps method number to operation */
@@ -70,10 +70,10 @@
 void proto_register(int srv, proto_t *proto);
 proto_t *proto_get_by_srv(int srv);
-proto_t *proto_new(char *name);
+proto_t *proto_new(const char *name);
 void proto_delete(proto_t *proto);
 void proto_add_oper(proto_t *proto, int method, oper_t *oper);
 oper_t *proto_get_oper(proto_t *proto, int method);
 
-oper_t *oper_new(char *name, int argc, val_type_t *arg_types,
+oper_t *oper_new(const char *name, int argc, val_type_t *arg_types,
     val_type_t rv_type, int respc, val_type_t *resp_types);
 
Index: uspace/app/trace/syscalls.h
===================================================================
--- uspace/app/trace/syscalls.h	(revision a634485c00ca23ba2df2fecef2d928929debee43)
+++ uspace/app/trace/syscalls.h	(revision a000878c0dee83a08f032207ffd800c201fca95b)
@@ -39,5 +39,5 @@
 
 typedef struct {
-	char *name;
+	const char *name;
 	int n_args;
 	val_type_t rv_type;
Index: uspace/app/trace/trace.c
===================================================================
--- uspace/app/trace/trace.c	(revision a634485c00ca23ba2df2fecef2d928929debee43)
+++ uspace/app/trace/trace.c	(revision a000878c0dee83a08f032207ffd800c201fca95b)
@@ -585,5 +585,5 @@
 }
 
-static loader_t *preload_task(const char *path, char *const argv[],
+static loader_t *preload_task(const char *path, char **argv,
     task_id_t *task_id)
 {
@@ -591,5 +591,5 @@
 	int rc;
 
-	/* Spawn a program loader */	
+	/* Spawn a program loader */
 	ldr = loader_connect();
 	if (ldr == NULL)
@@ -607,5 +607,5 @@
 
 	/* Send arguments */
-	rc = loader_set_args(ldr, argv);
+	rc = loader_set_args(ldr, (const char **) argv);
 	if (rc != EOK)
 		goto error;
@@ -870,25 +870,31 @@
 }
 
-static display_mask_t parse_display_mask(char *text)
+static display_mask_t parse_display_mask(const char *text)
 {
 	display_mask_t dm;
-	char *c;
-
-	c = text;
-
+	const char *c = text;
+	
 	while (*c) {
 		switch (*c) {
-		case 't': dm = dm | DM_THREAD; break;
-		case 's': dm = dm | DM_SYSCALL; break;
-		case 'i': dm = dm | DM_IPC; break;
-		case 'p': dm = dm | DM_SYSTEM | DM_USER; break;
+		case 't':
+			dm = dm | DM_THREAD;
+			break;
+		case 's':
+			dm = dm | DM_SYSCALL;
+			break;
+		case 'i':
+			dm = dm | DM_IPC;
+			break;
+		case 'p':
+			dm = dm | DM_SYSTEM | DM_USER;
+			break;
 		default:
 			printf("Unexpected event type '%c'.\n", *c);
 			exit(1);
 		}
-
+		
 		++c;
 	}
-
+	
 	return dm;
 }
@@ -896,13 +902,13 @@
 static int parse_args(int argc, char *argv[])
 {
-	char *arg;
 	char *err_p;
 
 	task_id = 0;
 
-	--argc; ++argv;
+	--argc;
+	++argv;
 
 	while (argc > 0) {
-		arg = *argv;
+		char *arg = *argv;
 		if (arg[0] == '+') {
 			display_mask = parse_display_mask(&arg[1]);
@@ -910,5 +916,6 @@
 			if (arg[1] == 't') {
 				/* Trace an already running task */
-				--argc; ++argv;
+				--argc;
+				++argv;
 				task_id = strtol(*argv, &err_p, 10);
 				task_ldr = NULL;
@@ -927,10 +934,12 @@
 			break;
 		}
-
-		--argc; ++argv;
+		
+		--argc;
+		++argv;
 	}
 
 	if (task_id != 0) {
-		if (argc == 0) return 0;
+		if (argc == 0)
+			return 0;
 		printf("Extra arguments\n");
 		print_syntax();
@@ -946,8 +955,9 @@
 	/* Preload the specified program file. */
 	printf("Spawning '%s' with arguments:\n", *argv);
-	{
-		char **cp = argv;
-		while (*cp) printf("'%s'\n", *cp++);
-	}
+	
+	char **cp = argv;
+	while (*cp)
+		printf("'%s'\n", *cp++);
+	
 	task_ldr = preload_task(*argv, argv, &task_id);
 	task_wait_for = true;
Index: uspace/lib/libc/Makefile.toolchain
===================================================================
--- uspace/lib/libc/Makefile.toolchain	(revision a634485c00ca23ba2df2fecef2d928929debee43)
+++ uspace/lib/libc/Makefile.toolchain	(revision a000878c0dee83a08f032207ffd800c201fca95b)
@@ -27,22 +27,26 @@
 #
 
-GCC_CFLAGS = -I$(LIBC_PREFIX)/include -O3 -imacros $(LIBC_PREFIX)/../../../config.h \
+OPTIMIZATION = 3
+
+GCC_CFLAGS = -I$(LIBC_PREFIX)/include -O$(OPTIMIZATION) -imacros $(LIBC_PREFIX)/../../../config.h \
 	-fexec-charset=UTF-8 -fwide-exec-charset=UTF-32$(ENDIANESS) \
 	-finput-charset=UTF-8 -ffreestanding -fno-builtin -nostdlib -nostdinc \
 	-Wall -Wextra -Wno-clobbered -Wno-unused-parameter -Wmissing-prototypes \
-	-Werror-implicit-function-declaration -Werror -pipe -g -D__$(ENDIANESS)__
+	-Werror-implicit-function-declaration -Wwrite-strings \
+	-Werror -pipe -g -D__$(ENDIANESS)__
 
-ICC_CFLAGS = -I$(LIBC_PREFIX)/include -O3 -imacros $(LIBC_PREFIX)/../../../config.h \
+ICC_CFLAGS = -I$(LIBC_PREFIX)/include -O$(OPTIMIZATION) -imacros $(LIBC_PREFIX)/../../../config.h \
+	-fexec-charset=UTF-8 -fwide-exec-charset=UTF-32$(ENDIANESS) \
+	-finput-charset=UTF-8 -ffreestanding -fno-builtin -nostdlib -nostdinc \
+	-Wall -Wextra -Wno-clobbered -Wno-unused-parameter -Wmissing-prototypes \
+	-Werror-implicit-function-declaration -Wwrite-strings \
+	-Werror -pipe -g -D__$(ENDIANESS)__
+
+CLANG_CFLAGS = -I$(LIBC_PREFIX)/include -O$(OPTIMIZATION) -imacros $(LIBC_PREFIX)/../../../config.h \
 	-fexec-charset=UTF-8 -fwide-exec-charset=UTF-32$(ENDIANESS) \
 	-finput-charset=UTF-8 -ffreestanding -fno-builtin -nostdlib -nostdinc \
 	-Wall -Wextra -Wno-unused-parameter -Wmissing-prototypes \
-	-Werror-implicit-function-declaration -Werror -pipe -g -D__$(ENDIANESS)__
-
-CLANG_CFLAGS = -I$(LIBC_PREFIX)/include -O3 -imacros $(LIBC_PREFIX)/../../../config.h \
-	-fexec-charset=UTF-8 -fwide-exec-charset=UTF-32$(ENDIANESS) \
-	-finput-charset=UTF-8 -ffreestanding -fno-builtin -nostdlib -nostdinc \
-	-Wall -Wextra -Wno-unused-parameter -Wmissing-prototypes \
-	-Werror-implicit-function-declaration -pipe -g -arch $(CLANG_ARCH) \
-	-D__$(ENDIANESS)__
+	-Werror-implicit-function-declaration -Wwrite-strings \
+	-pipe -g -arch $(CLANG_ARCH) -D__$(ENDIANESS)__
 
 LFLAGS = -M -N $(SOFTINT_PREFIX)/libsoftint.a
Index: uspace/lib/libc/generic/loader.c
===================================================================
--- uspace/lib/libc/generic/loader.c	(revision a634485c00ca23ba2df2fecef2d928929debee43)
+++ uspace/lib/libc/generic/loader.c	(revision a000878c0dee83a08f032207ffd800c201fca95b)
@@ -183,5 +183,5 @@
  *
  */
-int loader_set_args(loader_t *ldr, char *const argv[])
+int loader_set_args(loader_t *ldr, const char *const argv[])
 {
 	/*
@@ -189,5 +189,5 @@
 	 * compute size of the buffer needed.
 	 */
-	char *const *ap = argv;
+	const char *const *ap = argv;
 	size_t buffer_size = 0;
 	while (*ap != NULL) {
Index: uspace/lib/libc/generic/sysinfo.c
===================================================================
--- uspace/lib/libc/generic/sysinfo.c	(revision a634485c00ca23ba2df2fecef2d928929debee43)
+++ uspace/lib/libc/generic/sysinfo.c	(revision a000878c0dee83a08f032207ffd800c201fca95b)
@@ -37,7 +37,7 @@
 #include <string.h>
 
-sysarg_t sysinfo_value(char *name)
+sysarg_t sysinfo_value(const char *name)
 {
-	return __SYSCALL2(SYS_SYSINFO_VALUE, (sysarg_t ) name,
+	return __SYSCALL2(SYS_SYSINFO_VALUE, (sysarg_t) name,
 	    (sysarg_t) str_size(name));
 }
Index: uspace/lib/libc/generic/task.c
===================================================================
--- uspace/lib/libc/generic/task.c	(revision a634485c00ca23ba2df2fecef2d928929debee43)
+++ uspace/lib/libc/generic/task.c	(revision a000878c0dee83a08f032207ffd800c201fca95b)
@@ -76,5 +76,5 @@
  *
  */
-task_id_t task_spawn(const char *path, char *const args[])
+task_id_t task_spawn(const char *path, const char *const args[])
 {
 	/* Connect to a program loader. */
Index: uspace/lib/libc/generic/thread.c
===================================================================
--- uspace/lib/libc/generic/thread.c	(revision a634485c00ca23ba2df2fecef2d928929debee43)
+++ uspace/lib/libc/generic/thread.c	(revision a000878c0dee83a08f032207ffd800c201fca95b)
@@ -86,5 +86,5 @@
  * @return Zero on success or a code from @ref errno.h on failure.
  */
-int thread_create(void (* function)(void *), void *arg, char *name,
+int thread_create(void (* function)(void *), void *arg, const char *name,
     thread_id_t *tid)
 {
Index: uspace/lib/libc/include/loader/loader.h
===================================================================
--- uspace/lib/libc/include/loader/loader.h	(revision a634485c00ca23ba2df2fecef2d928929debee43)
+++ uspace/lib/libc/include/loader/loader.h	(revision a000878c0dee83a08f032207ffd800c201fca95b)
@@ -51,5 +51,5 @@
 extern int loader_set_cwd(loader_t *);
 extern int loader_set_pathname(loader_t *, const char *);
-extern int loader_set_args(loader_t *, char *const[]);
+extern int loader_set_args(loader_t *, const char *const[]);
 extern int loader_set_files(loader_t *, fdi_node_t *const[]);
 extern int loader_load_program(loader_t *);
Index: uspace/lib/libc/include/sysinfo.h
===================================================================
--- uspace/lib/libc/include/sysinfo.h	(revision a634485c00ca23ba2df2fecef2d928929debee43)
+++ uspace/lib/libc/include/sysinfo.h	(revision a000878c0dee83a08f032207ffd800c201fca95b)
@@ -40,5 +40,5 @@
 #include <string.h>
 
-sysarg_t sysinfo_value(char *name);
+sysarg_t sysinfo_value(const char *name);
 
 #endif
Index: uspace/lib/libc/include/task.h
===================================================================
--- uspace/lib/libc/include/task.h	(revision a634485c00ca23ba2df2fecef2d928929debee43)
+++ uspace/lib/libc/include/task.h	(revision a000878c0dee83a08f032207ffd800c201fca95b)
@@ -47,5 +47,5 @@
 extern task_id_t task_get_id(void);
 extern int task_set_name(const char *name);
-extern task_id_t task_spawn(const char *path, char *const argv[]);
+extern task_id_t task_spawn(const char *path, const char *const argv[]);
 extern int task_wait(task_id_t id, task_exit_t *texit, int *retval);
 extern int task_retval(int val);
Index: uspace/lib/libc/include/thread.h
===================================================================
--- uspace/lib/libc/include/thread.h	(revision a634485c00ca23ba2df2fecef2d928929debee43)
+++ uspace/lib/libc/include/thread.h	(revision a000878c0dee83a08f032207ffd800c201fca95b)
@@ -45,5 +45,5 @@
 extern void __thread_main(uspace_arg_t *);
 
-extern int thread_create(void (*)(void *), void *, char *, thread_id_t *);
+extern int thread_create(void (*)(void *), void *, const char *, thread_id_t *);
 extern void thread_exit(int) __attribute__ ((noreturn));
 extern void thread_detach(thread_id_t);
Index: uspace/lib/libpci/access.c
===================================================================
--- uspace/lib/libpci/access.c	(revision a634485c00ca23ba2df2fecef2d928929debee43)
+++ uspace/lib/libpci/access.c	(revision a000878c0dee83a08f032207ffd800c201fca95b)
@@ -51,5 +51,5 @@
 }
 
-static void pci_generic_error(char *msg, ...)
+static void pci_generic_error(const char *msg, ...)
 {
 	va_list args;
@@ -62,5 +62,5 @@
 }
 
-static void pci_generic_warn(char *msg, ...)
+static void pci_generic_warn(const char *msg, ...)
 {
 	va_list args;
@@ -72,5 +72,5 @@
 }
 
-static void pci_generic_debug(char *msg, ...)
+static void pci_generic_debug(const char *msg, ...)
 {
 	va_list args;
@@ -81,5 +81,5 @@
 }
 
-static void pci_null_debug(char *msg UNUSED, ...)
+static void pci_null_debug(const char *msg UNUSED, ...)
 {
 }
Index: uspace/lib/libpci/internal.h
===================================================================
--- uspace/lib/libpci/internal.h	(revision a634485c00ca23ba2df2fecef2d928929debee43)
+++ uspace/lib/libpci/internal.h	(revision a000878c0dee83a08f032207ffd800c201fca95b)
@@ -13,5 +13,5 @@
 
 struct pci_methods {
-	char *name;
+	const char *name;
 	void (*config) (struct pci_access *);
 	int (*detect) (struct pci_access *);
Index: uspace/lib/libpci/names.c
===================================================================
--- uspace/lib/libpci/names.c	(revision a634485c00ca23ba2df2fecef2d928929debee43)
+++ uspace/lib/libpci/names.c	(revision a000878c0dee83a08f032207ffd800c201fca95b)
@@ -299,5 +299,5 @@
 }
 
-char *pci_lookup_name(struct pci_access *a, char *buf, int size, int flags,
+const char *pci_lookup_name(struct pci_access *a, char *buf, int size, int flags,
 		      ...)
 {
Index: uspace/lib/libpci/pci.h
===================================================================
--- uspace/lib/libpci/pci.h	(revision a634485c00ca23ba2df2fecef2d928929debee43)
+++ uspace/lib/libpci/pci.h	(revision a000878c0dee83a08f032207ffd800c201fca95b)
@@ -40,7 +40,7 @@
 
 	/* Functions you can override: */
-	void (*error) (char *msg, ...);	/* Write error message and quit */
-	void (*warning) (char *msg, ...);	/* Write a warning message */
-	void (*debug) (char *msg, ...);	/* Write a debugging message */
+	void (*error) (const char *msg, ...);	/* Write error message and quit */
+	void (*warning) (const char *msg, ...);	/* Write a warning message */
+	void (*debug) (const char *msg, ...);	/* Write a debugging message */
 
 	struct pci_dev *devices;	/* Devices found on this bus */
@@ -128,6 +128,6 @@
  */
 
-char *pci_lookup_name(struct pci_access *a, char *buf, int size, int flags,
-		      ...);
+const char *pci_lookup_name(struct pci_access *a, char *buf, int size,
+    int flags, ...);
 
 int pci_load_name_list(struct pci_access *a);	/* Called automatically by pci_lookup_*() when needed; returns success */
Index: uspace/srv/hid/adb_mouse/adb_dev.c
===================================================================
--- uspace/srv/hid/adb_mouse/adb_dev.c	(revision a634485c00ca23ba2df2fecef2d928929debee43)
+++ uspace/srv/hid/adb_mouse/adb_dev.c	(revision a000878c0dee83a08f032207ffd800c201fca95b)
@@ -50,5 +50,5 @@
 int adb_dev_init(void)
 {
-	char *input = "/dev/adb/mouse";
+	const char *input = "/dev/adb/mouse";
 	int input_fd;
 
Index: uspace/srv/hid/char_mouse/chardev.c
===================================================================
--- uspace/srv/hid/char_mouse/chardev.c	(revision a634485c00ca23ba2df2fecef2d928929debee43)
+++ uspace/srv/hid/char_mouse/chardev.c	(revision a000878c0dee83a08f032207ffd800c201fca95b)
@@ -52,5 +52,5 @@
 int mouse_port_init(void)
 {
-	char *input = "/dev/char/ps2b";
+	const char *input = "/dev/char/ps2b";
 	int input_fd;
 
Index: uspace/srv/hid/fb/serial_console.c
===================================================================
--- uspace/srv/hid/fb/serial_console.c	(revision a634485c00ca23ba2df2fecef2d928929debee43)
+++ uspace/srv/hid/fb/serial_console.c	(revision a000878c0dee83a08f032207ffd800c201fca95b)
@@ -100,5 +100,5 @@
 };
 
-void serial_puts(char *str)
+void serial_puts(const char *str)
 {
 	while (*str)
Index: uspace/srv/hid/fb/serial_console.h
===================================================================
--- uspace/srv/hid/fb/serial_console.h	(revision a634485c00ca23ba2df2fecef2d928929debee43)
+++ uspace/srv/hid/fb/serial_console.h	(revision a000878c0dee83a08f032207ffd800c201fca95b)
@@ -43,5 +43,5 @@
 typedef void (*putc_function_t)(char);
 
-void serial_puts(char *str);
+void serial_puts(const char *str);
 void serial_goto(const unsigned int col, const unsigned int row);
 void serial_clrscr(void);
Index: uspace/srv/hid/kbd/port/adb.c
===================================================================
--- uspace/srv/hid/kbd/port/adb.c	(revision a634485c00ca23ba2df2fecef2d928929debee43)
+++ uspace/srv/hid/kbd/port/adb.c	(revision a000878c0dee83a08f032207ffd800c201fca95b)
@@ -53,5 +53,5 @@
 int kbd_port_init(void)
 {
-	char *input = "/dev/adb/kbd";
+	const char *input = "/dev/adb/kbd";
 	int input_fd;
 
Index: uspace/srv/hid/kbd/port/chardev.c
===================================================================
--- uspace/srv/hid/kbd/port/chardev.c	(revision a634485c00ca23ba2df2fecef2d928929debee43)
+++ uspace/srv/hid/kbd/port/chardev.c	(revision a000878c0dee83a08f032207ffd800c201fca95b)
@@ -52,5 +52,5 @@
 int kbd_port_init(void)
 {
-	char *input = "/dev/char/ps2a";
+	const char *input = "/dev/char/ps2a";
 	int input_fd;
 
Index: uspace/srv/loader/elf_load.c
===================================================================
--- uspace/srv/loader/elf_load.c	(revision a634485c00ca23ba2df2fecef2d928929debee43)
+++ uspace/srv/loader/elf_load.c	(revision a000878c0dee83a08f032207ffd800c201fca95b)
@@ -60,5 +60,5 @@
 #define DPRINTF(...)
 
-static char *error_codes[] = {
+static const char *error_codes[] = {
 	"no error",
 	"invalid image",
@@ -95,12 +95,13 @@
  * pointed to by @a info.
  *
- * @param file_name	Path to the ELF file.
- * @param so_bias	Bias to use if the file is a shared object.
- * @param info		Pointer to a structure for storing information
- *			extracted from the binary.
+ * @param file_name Path to the ELF file.
+ * @param so_bias   Bias to use if the file is a shared object.
+ * @param info      Pointer to a structure for storing information
+ *                  extracted from the binary.
  *
  * @return EOK on success or negative error code.
- */
-int elf_load_file(char *file_name, size_t so_bias, elf_info_t *info)
+ *
+ */
+int elf_load_file(const char *file_name, size_t so_bias, elf_info_t *info)
 {
 	elf_ld_t elf;
@@ -130,5 +131,6 @@
  * earlier with elf_load_file(). This function does not return.
  *
- * @param info	Info structure filled earlier by elf_load_file()
+ * @param info Info structure filled earlier by elf_load_file()
+ *
  */
 void elf_run(elf_info_t *info, pcb_t *pcb)
@@ -280,5 +282,5 @@
  * @return NULL terminated description of error.
  */
-char *elf_error(unsigned int rc)
+const char *elf_error(unsigned int rc)
 {
 	assert(rc < sizeof(error_codes) / sizeof(char *));
Index: uspace/srv/loader/include/elf.h
===================================================================
--- uspace/srv/loader/include/elf.h	(revision a634485c00ca23ba2df2fecef2d928929debee43)
+++ uspace/srv/loader/include/elf.h	(revision a000878c0dee83a08f032207ffd800c201fca95b)
@@ -337,5 +337,5 @@
 #endif
 
-extern char *elf_error(unsigned int rc);
+extern const char *elf_error(unsigned int rc);
 
 #endif
Index: uspace/srv/loader/include/elf_load.h
===================================================================
--- uspace/srv/loader/include/elf_load.h	(revision a634485c00ca23ba2df2fecef2d928929debee43)
+++ uspace/srv/loader/include/elf_load.h	(revision a000878c0dee83a08f032207ffd800c201fca95b)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup generic	
+/** @addtogroup generic
  * @{
  */
@@ -51,5 +51,5 @@
 
 	/** ELF interpreter name or NULL if statically-linked */
-	char *interp;
+	const char *interp;
 
 	/** Pointer to the dynamic section */
@@ -74,5 +74,5 @@
 } elf_ld_t;
 
-int elf_load_file(char *file_name, size_t so_bias, elf_info_t *info);
+int elf_load_file(const char *file_name, size_t so_bias, elf_info_t *info);
 void elf_run(elf_info_t *info, pcb_t *pcb);
 void elf_create_pcb(elf_info_t *info, pcb_t *pcb);
